package bham.cs.fsc.exp;
import bham.cs.fsc.ui.*;
import bham.cs.fsc.gp.*;
import java.awt.Frame;
import java.awt.Rectangle;
import java.awt.Button;
import java.awt.Event;
import java.awt.Label;
import java.awt.Component;
import java.awt.Color;
import java.awt.TextArea;
import java.awt.TextComponent;
import java.awt.Panel;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.FileDialog;
import java.awt.Font;
import java.io.File;

/**
* 
* This is the modal dialog for requesting the user to power on their modem.
*
* @version 1.0
* @author Phyllis Chong (<a href="mailto:fsc@cs.bham.ac.uk">fsc@cs.bham.ac.uk</a>)
*/
public class ModemDialog extends Dialog {
     
	private Button okButton;
	private Button cancelButton;

        private TextArea msgText;

        Frame parent;
  
        private boolean modemOn = false;


  //public SaveFileDialog(Frame parent, GP g, saveFileThread s) {
  public ModemDialog(Frame parent, String msg, String title) {
    //super(parent, new Rectangle(8, 8, 265, 160),
    super(parent, new Rectangle(8, 8, 375, 155),
				title);
		//	Weird: The AWT is supposed to make the dialog window a child
		//	of the main frame. But it takes the desktop top left corner 
		//	as coordinate	origin instead of the frame's.
		//	On some systems, modal dialogs are fixed on the screen, therefore,
		//	I have to put my dialog near the top left corner, so that it is fully
		//	visible.
		//setResizable(false);
		setResizable(true);
		
		this.parent = parent;

		Panel buttonPanel = new Panel();
		buttonPanel.setLayout(new StackLayout(StackLayout.HORIZONTAL));
		buttonPanel.setFont(new Font("Courier",Font.BOLD,12));
		okButton = new Button("OK");
		buttonPanel.add("Tall Wide", okButton);
		buttonPanel.setFont(new Font("Courier",Font.PLAIN,12));
		cancelButton = new Button("Cancel");
		buttonPanel.add("Tall Wide", cancelButton);

		Panel textPanel = new Panel();
		textPanel.setLayout(new FlowLayout()); //default layout for panels
		textPanel.setFont(new Font("Courier",Font.PLAIN,12));
		//msgText = new TextArea(msg,12,55,TextArea.SCROLLBARS_NONE);
		//msgText = new TextArea(12,55);
		msgText = new TextArea(10,75);
	        msgText.setText(msg);
		msgText.setEditable(false);
		textPanel.add(msgText);

		setLayout(new StackLayout(StackLayout.VERTICAL, 8));
		add("Wide Tall Flush", textPanel);
		add("Bottom Wide", buttonPanel);	
	}

	/**
	* Is called whenever the user clicks a command button.
	*/
	public boolean action(Event evt, Object what) {
		if (evt.target == okButton) {
		  System.out.println("okButton pressed. Setting modemOn to true");
		    modemOn = true;
		    dispose();
		 
	          return true;
		}
		
		if (evt.target == cancelButton) {
		  System.out.println("cancelButton pressed. Setting modemOn to false");
		  modemOn = false;
		  dispose();
		  return true;
		}

		return false;
	}

        
  public boolean getDialogAns() {
    System.out.println("returning reply of dialog.");
    //dispose();
    //System.out.println("window disposed. returning modemOn status.");
    return modemOn;
    
  }


}








