package bham.cs.fsc.exp;
import bham.cs.fsc.ui.*;
import bham.cs.fsc.gp.*;
//import gp.approx.ui.*;
import java.awt.Frame;
import java.awt.Rectangle;
import java.awt.Button;
import java.awt.Event;
import java.awt.Label;
import java.awt.Component;
import java.awt.Color;
import java.awt.TextArea;
import java.awt.TextComponent;
import java.awt.Panel;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.FileDialog;
import java.awt.Font;
import java.io.File;

/**
* 
* This is the modal dialog for saving a population and seed from a file when DGPClient is run as an application.
*
* @version 1.0
* @author Phyllis Chong (<a href="mailto:fsc@cs.bham.ac.uk">fsc@cs.bham.ac.uk</a>)
*/
public class SaveFileDialog extends Dialog {
     
	private Button defaultButton;
	private Button cancelButton;
        private Button dialogButton;
        private TextArea fileLoadText;
        //private Label status;

        //DGPClient dgpClient;

        //String popFileName;
        //File popFile;
        GP g;
        //saveFileThread s;
        Frame parent;


  //public SaveFileDialog(Frame parent, GP g, saveFileThread s) {
  public SaveFileDialog(Frame parent, GP g) {
	        super(parent, new Rectangle(8, 8, 290, 135),
				"Save File Dialog");
		//	Weird: The AWT is supposed to make the dialog window a child
		//	of the main frame. But it takes the desktop top left corner 
		//	as coordinate	origin instead of the frame's.
		//	On some systems, modal dialogs are fixed on the screen, therefore,
		//	I have to put my dialog near the top left corner, so that it is fully
		//	visible.
		//setResizable(false);
		setResizable(true);
		
		this.g = g;
		this.parent = parent;
		//this.s = s;

		//this.dgpClient = dgpClient;
		
		Panel buttonPanel = new Panel();
		buttonPanel.setLayout(new StackLayout(StackLayout.HORIZONTAL));
		buttonPanel.setFont(new Font("Courier",Font.BOLD,11));
		defaultButton = new Button("Save to default file");
		buttonPanel.add("Tall Wide", defaultButton);
		dialogButton = new Button("Specify file");
		buttonPanel.add("Tall Wide", dialogButton);
		//buttonPanel.add("Tall Wide", new Panel());	// just as a spacer
		cancelButton = new Button("Cancel");
		buttonPanel.add("Tall Wide", cancelButton);

		Panel textPanel = new Panel();
		//textPanel.setLayout(new BorderLayout());
		textPanel.setLayout(new FlowLayout()); //default layout for panels
		textPanel.setFont(new Font("Courier",Font.PLAIN,11));
		fileLoadText = new TextArea("This run has been prematurely terminated.\nPlease save the population and seed into a file so that you can continue the run from where it stopped the next time you invoke DGPClient.\nClick on the 'Save to default file' button to save population and seed into the default file 'GP.pop' or you may specify your own file name by clicking on the 'Specify file' button.\nIf, however, you do not wish to save the population and seed, please click on the 'Cancel' button.",13,70,TextArea.SCROLLBARS_NONE);
		//fileLoadText.setFont("Courier",Font.Plain,11);
		fileLoadText.setEditable(false);
		//textPanel.add("Center", fileLoadText);
		textPanel.add(fileLoadText);

		setLayout(new StackLayout(StackLayout.VERTICAL, 8));
		add("Wide Tall Flush", textPanel);
		add("Bottom Wide", buttonPanel);	
	}

	/**
	* Is called whenever the user clicks a command button.
	*/
	public boolean action(Event evt, Object what) {
		if (evt.target == defaultButton) {
		  System.out.println("Save to default file button pressed");
		  /*
		  popFile = new File("GP.pop");
		  if (popFile.exists()) {
		  */
		    g.fileName = "GP.pop";
		    System.out.println("'Save to default file' button pressed. g.fileName set to GP.pop.");
		    //s.t.finished();
		    dispose();
		 
	          return true;
		}
		
		if (evt.target == dialogButton) {
		  System.out.println("Specify File button pressed");
		  //Create a file dialog to query the user for a filename.
		  FileDialog f = new FileDialog(parent, "Save population to file", FileDialog.SAVE);
		  f.show();
		  f.pack();
		  /*
		  popFileName = f.getFile();
		  popFile = new File(popFileName);
		  if (popFile.exists()) {
		  */
		  //g.fileName = popFileName;
		  String fileDir = f.getDirectory();
		  System.out.println("Directory to save pop to : " + fileDir);
		  String fileNm = f.getFile();
		  System.out.println("Name of file to save pop to : " + fileNm);
		  //g.fileName = f.getFile();
		  if ((fileDir == null) || (fileNm == null)) {
		    g.fileName = null;
		    dispose();
		  }
		  else 
		    if (fileDir.trim() == "./") {
		      FileIODialog n = new FileIODialog(parent,"File name './' is NOT valid.\nPlease provide another file name.", "Invalid File Name");
		      n.show();
		      n.pack();
		    }
		    else {  
		      //if (((fileDir != null) && (fileDir.trim() != "./")) && ((fileNm != null) && (fileNm.trim() != ""))) {
			g.fileName = fileDir + fileNm;
			System.out.println("'Specify File' button pressed. g.fileName set to " + g.fileName);
			//s.t.finished();
			dispose();
		    } 
		  /*
		  else {
		    g.fileName = null;
		  }
		  */
		  //dispose();
		  
		  return true;
		}

		if (evt.target == cancelButton) {
		  System.out.println("Cancel button pressed.");
		  g.fileName = null;
		  System.out.println("'Cancel' button pressed. g.fileName set to null");
		  //s.t.finished();
		  dispose();
		  return true;
		}
		return false;
	}


}








