//package gp;
package bham.cs.fsc.gp;

import java.util.Observable;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.rmi.*;
import java.net.*;
import java.io.*;
import bham.cs.fsc.ui.*;
//import gp.*;


public abstract class Program implements Cloneable, Serializable {
/**
*	This is the base class for all kinds of tree nodes.
*/
	/**
	* @param level the current recursion level when descending a subtree
	* @return the text representation of the subtree
	*/
	public abstract String toString(int level);

	/**
	* @return a text description of the node. While toString() prints
	*		the value of a subtree, getName() returns something like the
	*		class name of this very node. getName() can be used to preset
	*		the choice lists for the function and terminal sets.
	*/
	public abstract String getName();

	/**
	* @return a series of blanks proportional to the recursion level
	*/
	public static String indent(int level) {
		String s = new String();
		for (int i = 0; i < level; i++) {
			s = s + "  ";
		}
		return s;
	}

	/**
	* @return the value of the subtree, evaluated at x, i.e. y = f(x)
	*/
        //abstract double eval(double x);

        /* declared public so that it can be redefined in subclasses (classes that extend the Program class) from another package. */
        public abstract double eval(double x);

	/**
	* @return the number of nodes in this subtree
	*/
	abstract int countNodes();

	/**
	* @return the number of nodes in this subtree satisfying a certain
	*		condition
	*/
	abstract int countNodes(Condition cond);

	/**
	* @return a deep copy of the subtree
	*/
  abstract protected Object clone();
  //public abstract Object clone();
}














