package bham.cs.fsc.gp.approx;

import java.util.Observable;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.rmi.*;
import java.net.*;
import java.io.*;
import bham.cs.fsc.gp.*;
import bham.cs.fsc.ui.*;

public class RandomConstant extends Terminal implements Serializable {
	static final double MIN = -4.0;
	static final double MAX = +4.0;
	double value;

	public RandomConstant() {
		value = GP.random.nextDouble() * (MAX - MIN) + MIN;
	}

	private RandomConstant(double value) {
		this.value = value;
	}

	public String toString(int level) {
		return Program.indent(level) + value;
	}

	protected Object clone() {
		return new RandomConstant(this.value); };

	public String getName() {
		return "Random Constant";
	}

	public double eval(double x) {
		return value;
	}

}
